function getComments(codeText) {
  const comments = [];
  let ignore = false;
  let ignoreNextQuote = false;
  let currentCommentBuffer = '';

  let readingComment = false;
  let commentType = 0;

  for(let i = 0; i < codeText.length; ++i) {
    let c = codeText[i];
    if(!readingComment) {
      if(c == '\\') {
        ignoreNextQuote = true;
        continue;
      }
    
      if(c == '"' && !ignoreNextQuote) {
        ignore = !ignore;
        continue;
      }
      ignoreNextQuote = false;
    }
    else {
      if(commentType == 1) {
        if(c == '\n' || c == '\r') {
          comments.push({
            text: currentCommentBuffer,
            type: (commentType == 1 ? 'line' : 'block')
          });
          readingComment = false;
          currentCommentBuffer = '';
          continue;
        }
      }
      else {
        if(c == '*' && codeText[i + 1] == '/') {
          comments.push({
            text: currentCommentBuffer,
            type: (commentType == 1 ? 'line' : 'block')
          });
          readingComment = false;
          currentCommentBuffer = '';
          ++i;
          continue;
        }
      }
      currentCommentBuffer += c;
      continue;
    }
    if(ignore)
      continue;
    
    if(c == '/' && codeText[i + 1] == '/') {
      i++;
      readingComment = true;
      commentType = 1;
    }
    else if(c == '/' && codeText[i + 1] == '*') {
      i++;
      readingComment = true;
      commentType = 2;
    }
  }

  if(readingComment) {
    comments.push({
      text: currentCommentBuffer,
      type: (commentType == 1 ? 'line' : 'block')
    });
  }
  return comments;
}

module.exports = getComments;
